Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/ice_2.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/ice_2.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/ice_2.F90	(revision 2613)
@@ -4,6 +4,7 @@
    !! Sea Ice physics:  diagnostics variables of ice defined in memory
    !!=====================================================================
-   !! History :  2.0  !  2003-08  (C. Ethe)  F90: Free form and module
-   !!            3.3  !  2009-05  (G.Garric) addition of the lim2_evp cas
+   !! History :  2.0  ! 2003-08  (C. Ethe)  F90: Free form and module
+   !!            3.3  ! 2009-05  (G.Garric) addition of the lim2_evp cas
+   !!            4.0  ! 2011-01  (A. R. Porter, STFC Daresbury) dynamical allocation
    !!----------------------------------------------------------------------
 #if defined key_lim2
@@ -16,6 +17,5 @@
    PRIVATE
    
-   ! Routine accessibility
-   PUBLIC    ice_alloc_2  !  Called in nemogcm.F90
+   PUBLIC    ice_alloc_2  !  Called in iceini_2.F90
 
    INTEGER , PUBLIC ::   numit     !: ice iteration index
@@ -124,93 +124,77 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   sxc2,  syc2,  sxxc2,  syyc2,  sxyc2    !: for heat content of 2nd ice layer
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   sxst,  syst,  sxxst,  syyst,  sxyst    !: for heat content of brine pockets
-
+   !!----------------------------------------------------------------------
+   CONTAINS
+
+   FUNCTION ice_alloc_2()
+      !!-----------------------------------------------------------------
+      !!               *** FUNCTION ice_alloc_2 ***
+      !!-----------------------------------------------------------------
+      USE in_out_manager, ONLY: ctl_warn
+      INTEGER :: ice_alloc_2     ! return value
+      INTEGER :: ierr(9)        ! Local variables
+      !!-----------------------------------------------------------------
+
+      ierr(:) = 0
+
+      ALLOCATE( ahiu(jpi,jpj) , pahu(jpi,jpj) ,                      &
+         &      ahiv(jpi,jpj) , pahv(jpi,jpj) , ust2s(jpi,jpj) , STAT=ierr(1) )
+
+      !* Ice Rheology
+#if defined key_lim2_vp
+      ALLOCATE( hsnm(jpi,jpj) , hicm(jpi,jpj) , STAT=ierr(2) )
 #else
+      ALLOCATE( stress1_i (jpi,jpj) , delta_i(jpi,jpj) , at_i(jpi,jpj) ,     &
+                stress2_i (jpi,jpj) , divu_i (jpi,jpj) , hsnm(jpi,jpj) ,     &
+                stress12_i(jpi,jpj) , shear_i(jpi,jpj) , hicm(jpi,jpj) , STAT=ierr(2) )
+#endif
+
+      ALLOCATE( rdvosif(jpi,jpj) , rdvobif(jpi,jpj) ,                      &
+         &      fdvolif(jpi,jpj) , rdvonif(jpi,jpj) ,                      &
+         &      sist   (jpi,jpj) , tfu    (jpi,jpj) , hicif(jpi,jpj) ,     &
+         &      hsnif  (jpi,jpj) , hicifp (jpi,jpj) , frld (jpi,jpj) , STAT=ierr(3) )
+
+      ALLOCATE(phicif(jpi,jpj) , pfrld  (jpi,jpj) , qstoif (jpi,jpj) ,     &
+         &     fbif  (jpi,jpj) , rdmsnif(jpi,jpj) , rdmicif(jpi,jpj) ,     &
+         &     qldif (jpi,jpj) , qcmif  (jpi,jpj) , fdtcn  (jpi,jpj) ,     &
+         &     qdtcn (jpi,jpj) , thcm   (jpi,jpj)                    , STAT=ierr(4) )
+
+      ALLOCATE(fstric(jpi,jpj) , ffltbif(jpi,jpj) , fscmbq(jpi,jpj) ,     &
+         &     fsbbq (jpi,jpj) , qfvbq  (jpi,jpj) , dmgwi (jpi,jpj) ,     &
+         &     u_ice (jpi,jpj) , v_ice  (jpi,jpj) ,                       &
+         &     u_oce (jpi,jpj) , v_oce  (jpi,jpj) ,                       &
+         &     tbif  (jpi,jpj,jplayersp1)                           , STAT=ierr(5))
+
+      !* moment used in the advection scheme
+      ALLOCATE(sxice (jpi,jpj) , syice (jpi,jpj) , sxxice(jpi,jpj) ,     &
+         &     syyice(jpi,jpj) , sxyice(jpi,jpj) ,                       &
+         &     sxsn  (jpi,jpj) , sysn  (jpi,jpj) , sxxsn (jpi,jpj) ,     &
+         &     syysn (jpi,jpj) , sxysn (jpi,jpj)                   , STAT=ierr(6) )
+      ALLOCATE(sxa   (jpi,jpj) , sya   (jpi,jpj) , sxxa  (jpi,jpj) ,     &
+         &     syya  (jpi,jpj) , sxya  (jpi,jpj) ,                       & 
+         &     sxc0  (jpi,jpj) , syc0  (jpi,jpj) , sxxc0 (jpi,jpj) ,     &
+         &     syyc0 (jpi,jpj) , sxyc0 (jpi,jpj)                   , STAT=ierr(7))
+      ALLOCATE(sxc1  (jpi,jpj) , syc1  (jpi,jpj) , sxxc1 (jpi,jpj) ,     &
+         &     syyc1 (jpi,jpj) , sxyc1 (jpi,jpj) ,                       &
+         &     sxc2  (jpi,jpj) , syc2  (jpi,jpj) , sxxc2 (jpi,jpj) ,     &
+         &     syyc2 (jpi,jpj) , sxyc2 (jpi,jpj)                   , STAT=ierr(8))
+      ALLOCATE(sxst  (jpi,jpj) , syst  (jpi,jpj) , sxxst (jpi,jpj) ,     &
+         &     syyst (jpi,jpj) , sxyst (jpi,jpj)                   , STAT=ierr(9))
+
+      ice_alloc_2 = MAXVAL( ierr )
+
+      IF( ice_alloc_2 /= 0 )   CALL ctl_warn('ice_alloc_2: failed to allocate arrays.')
+      !
+   END FUNCTION ice_alloc_2
+
+#else
    !!----------------------------------------------------------------------
    !!   Default option         Empty module        NO LIM 2.0 sea-ice model
    !!----------------------------------------------------------------------
 #endif
-
-   !!----------------------------------------------------------------------
+   !!-----------------------------------------------------------------
    !! NEMO/LIM2 3.3 , UCL - NEMO Consortium (2010)
    !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
-
-#if defined key_lim2
-   CONTAINS
-
-     FUNCTION ice_alloc_2()
-        !!-----------------------------------------------------------------
-        !!               *** Routine ice_alloc_2 ***
-        !!-----------------------------------------------------------------
-        USE in_out_manager, ONLY: ctl_warn
-        IMPLICIT none
-        INTEGER :: ice_alloc_2
-        ! Local variables
-        INTEGER :: ierr(9)
-        !!-----------------------------------------------------------------
-
-        ierr(:) = 0
-
-        ! What could be one huge allocate statement is broken-up to try to
-        ! stay within Fortran's max-line length limit.
-        ALLOCATE(ahiu(jpi,jpj), ahiv(jpi,jpj), &
-                 pahu(jpi,jpj), pahv(jpi,jpj), &
-                 ust2s(jpi,jpj), Stat=ierr(1))
-
-        ALLOCATE(                              &
-#if defined key_lim2_vp
-                 hsnm(jpi,jpj), hicm(jpi,jpj), &
-#else
-                 stress1_i(jpi,jpj), stress2_i(jpi,jpj), stress12_i(jpi,jpj), &
-                 delta_i(jpi,jpj),   divu_i(jpi,jpj),    shear_i(jpi,jpj),    &
-                 at_i(jpi,jpj), hsnm(jpi,jpj), hicm(jpi,jpj),                 &
-#endif
-                 Stat=ierr(2))
-
-        ALLOCATE(rdvosif(jpi,jpj), rdvobif(jpi,jpj),                          &
-                 fdvolif(jpi,jpj), rdvonif(jpi,jpj),                          &
-                 sist(jpi,jpj),    tfu(jpi,jpj),         hicif(jpi,jpj),      &
-                 hsnif(jpi,jpj),   hicifp(jpi,jpj),      frld(jpi,jpj),       &
-                 Stat=ierr(3))
-
-        ALLOCATE(phicif(jpi,jpj),  pfrld(jpi,jpj),       qstoif(jpi,jpj),     &
-                 fbif(jpi,jpj),    rdmsnif(jpi,jpj),     rdmicif(jpi,jpj),    &
-                 qldif(jpi,jpj),   qcmif(jpi,jpj),       fdtcn(jpi,jpj),      &
-                 qdtcn(jpi,jpj),   thcm(jpi,jpj),        Stat=ierr(4))
-
-        ALLOCATE(fstric(jpi,jpj),  ffltbif(jpi,jpj),     fscmbq(jpi,jpj),     &
-                 fsbbq(jpi,jpj),   qfvbq(jpi,jpj),       dmgwi(jpi,jpj),      &
-                 u_ice(jpi,jpj),   v_ice(jpi,jpj),                            &
-                 u_oce(jpi,jpj),   v_oce(jpi,jpj),                            &
-                 tbif(jpi,jpj,jplayersp1), Stat=ierr(5))
-
-        ALLOCATE(sxice(jpi,jpj),   syice(jpi,jpj),  sxxice(jpi,jpj),          &
-                 syyice(jpi,jpj),  sxyice(jpi,jpj),                           &
-                 sxsn(jpi,jpj),    sysn(jpi,jpj),  sxxsn(jpi,jpj),            &
-                 syysn(jpi,jpj),   sxysn(jpi,jpj), Stat=ierr(6))
-
-        ALLOCATE(sxa(jpi,jpj),     sya(jpi,jpj),   sxxa(jpi,jpj),             &
-                 syya(jpi,jpj),    sxya(jpi,jpj),                             & 
-                 sxc0(jpi,jpj),    syc0(jpi,jpj),  sxxc0(jpi,jpj),            &
-                 syyc0(jpi,jpj),   sxyc0(jpi,jpj), Stat=ierr(7))
-
-        ALLOCATE(sxc1(jpi,jpj),    syc1(jpi,jpj),  sxxc1(jpi,jpj),            &
-                 syyc1(jpi,jpj),   sxyc1(jpi,jpj),                            &
-                 sxc2(jpi,jpj),    syc2(jpi,jpj),  sxxc2(jpi,jpj),            &
-                 syyc2(jpi,jpj),   sxyc2(jpi,jpj), Stat=ierr(8))
-
-        ALLOCATE(sxst(jpi,jpj),    syst(jpi,jpj),  sxxst(jpi,jpj),            &
-                 syyst(jpi,jpj),   sxyst(jpi,jpj), Stat=ierr(9))
-
-        ice_alloc_2 = MAXVAL(ierr)
-
-        IF(ice_alloc_2 /= 0)THEN
-           CALL ctl_warn('ice_alloc_2: failed to allocate arrays.')
-        END IF
-
-     END FUNCTION ice_alloc_2
-
-#endif
-
 END MODULE ice_2
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/iceini_2.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/iceini_2.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/iceini_2.F90	(revision 2613)
@@ -4,7 +4,8 @@
    !!   Sea-ice model : LIM 2.0 Sea ice model Initialization
    !!======================================================================
-   !! History :   1.0  !  02-08  (G. Madec)  F90: Free form and modules
-   !!             2.0  !  03-08  (C. Ethe)  add ice_run
-   !!             3.3  !  09-05  (G.Garric, C. Bricaud) addition of the lim2_evp case
+   !! History :  1.0  ! 2002-08  (G. Madec)  F90: Free form and modules
+   !!            2.0  ! 2003-08  (C. Ethe)  add ice_run
+   !!            3.3  ! 2009-05  (G. Garric, C. Bricaud) addition of the lim2_evp case
+   !!            4.0  ! 2011-02  (G. Madec) dynamical allocation
    !!----------------------------------------------------------------------
 #if defined key_lim2
@@ -12,17 +13,19 @@
    !!   'key_lim2' :                                  LIM 2.0 sea-ice model
    !!----------------------------------------------------------------------
-   !!----------------------------------------------------------------------
    !!   ice_init_2       : sea-ice model initialization
    !!   ice_run_2        : Definition some run parameter for ice model
    !!----------------------------------------------------------------------
+   USE phycst           ! physical constants
    USE dom_oce          ! ocean domain
-   USE dom_ice_2        ! LIM2: ice domain
+   USE dom_ice_2        ! LIM2 ice domain
    USE sbc_oce          ! surface boundary condition: ocean
    USE sbc_ice          ! surface boundary condition: ice
-   USE phycst           ! Define parameters for the routines
-   USE ice_2            ! LIM2: ice variable
-   USE limmsh_2         ! LIM2: mesh
-   USE limistate_2      ! LIM2: initial state
-   USE limrst_2         ! LIM2: restart
+   USE thd_ice_2        ! LIM2 thermodynamical variables
+   USE limrhg           ! LIM2 rheology
+   USE ice_2            ! LIM2 ice variable
+   USE limmsh_2         ! LIM2 mesh
+   USE limistate_2      ! LIM2 initial state
+   USE limrst_2         ! LIM2 restart
+   USE limsbc_2         ! LIM2 surface boundary condition
    USE in_out_manager   ! I/O manager
       
@@ -33,5 +36,5 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/LIM2 3.3 , UCL - NEMO Consortium (2010)
+   !! NEMO/LIM2 4.0 , UCL - NEMO Consortium (2011)
    !! $Id$ 
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -45,5 +48,23 @@
       !! ** purpose :   initialisation of LIM-2 domain and variables  
       !!----------------------------------------------------------------------
+      INTEGER :: ierr
+      !!----------------------------------------------------------------------
       !
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'ice_init_2 : LIM-2 sea-ice - initialization'
+         WRITE(numout,*) '~~~~~~~~~~~   '
+      ENDIF
+      !                                ! Allocate the ice arrays
+      ierr =        ice_alloc_2    ()       ! ice variables
+      ierr = ierr + dom_ice_alloc_2()       ! domain
+      ierr = ierr + sbc_ice_alloc  ()       ! surface forcing
+      ierr = ierr + thd_ice_alloc_2()       ! thermodynamics
+#if ! defined key_lim2_vp
+      ierr = ierr + lim_rhg_alloc  ()
+#endif
+      IF( lk_mpp    )   CALL mpp_sum( ierr )
+      IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'ice_init_2 : unable to allocate ice arrays' )
+
       !                                ! Open the namelist file 
       CALL ctl_opn( numnam_ice, 'namelist_ice', 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, lwp ) 
@@ -61,6 +82,12 @@
       ENDIF
       !
-      tn_ice(:,:,1) = sist(:,:)        ! initialisation of ice temperature   
-      fr_i  (:,:) = 1.0 - frld(:,:)    ! initialisation of sea-ice fraction    
+      tn_ice(:,:,1) = sist(:,:)        ! ice temperature  known by the ocean
+      fr_i  (:,:)   = 1.0 - frld(:,:)  ! sea-ice fraction known by the ocean
+      !
+      CALL lim_sbc_init_2              ! ice surface boundary condition   
+      !
+      IF( lk_lim2_vp )   THEN   ;   WRITE(numout,*) '                VP  rheology - B-grid case'
+      ELSE                      ;   WRITE(numout,*) '                EVP rheology - C-grid case'
+      ENDIF
       !
    END SUBROUTINE ice_init_2
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limadv_2.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limadv_2.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limadv_2.F90	(revision 2613)
@@ -58,10 +58,9 @@
       !! Reference:  Prather, 1986, JGR, 91, D6. 6671-6681.
       !!--------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
-      USE wrk_nemo, ONLY: zf0 => wrk_2d_11, zfx => wrk_2d_12, zfy => wrk_2d_13
-      USE wrk_nemo, ONLY: zbet => wrk_2d_14, zfm => wrk_2d_15, zfxx => wrk_2d_16
-      USE wrk_nemo, ONLY: zfyy => wrk_2d_17, zfxy => wrk_2d_18, zalg => wrk_2d_19
-      USE wrk_nemo, ONLY: zalg1 => wrk_2d_20, zalg1q => wrk_2d_21
-      !!
+      USE wrk_nemo, ONLY:   wrk_use, wrk_release
+      USE wrk_nemo, ONLY:   zf0  => wrk_2d_11 , zfx   => wrk_2d_12 , zfy    => wrk_2d_13 , zbet => wrk_2d_14   ! 2D workspace
+      USE wrk_nemo, ONLY:   zfm  => wrk_2d_15 , zfxx  => wrk_2d_16 , zfyy   => wrk_2d_17 , zfxy => wrk_2d_18   !  -      -
+      USE wrk_nemo, ONLY:   zalg => wrk_2d_19 , zalg1 => wrk_2d_20 , zalg1q => wrk_2d_21                       !  -      -
+      !
       REAL(wp)                    , INTENT(in   ) ::   pdf                ! reduction factor for the time step
       REAL(wp)                    , INTENT(in   ) ::   pcrh               ! call lim_adv_x then lim_adv_y (=1) or the opposite (=0)
@@ -71,5 +70,5 @@
       REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) ::   psx , psy          ! 1st moments 
       REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) ::   psxx, psyy, psxy   ! 2nd moments
-      !! 
+      ! 
       INTEGER  ::   ji, jj                               ! dummy loop indices
       REAL(wp) ::   zs1max, zrdt, zslpmax, ztemp, zin0   ! temporary scalars
@@ -78,7 +77,6 @@
       !---------------------------------------------------------------------
 
-      IF(.NOT. wrk_use(2, 11,12,13,14,15,16,17,18,19,20,21))THEN
-         CALL ctl_stop('lim_adv_x_2 : requested workspace arrays unavailable.')
-         RETURN
+      IF( .NOT. wrk_use(2, 11,12,13,14,15,16,17,18,19,20,21) ) THEN
+         CALL ctl_stop( 'lim_adv_x_2 : requested workspace arrays unavailable.' )   ;   RETURN
       END IF
 
@@ -226,6 +224,6 @@
       ENDIF
       !
-      IF(.NOT. wrk_release(2, 11,12,13,14,15,16,17,18,19,20,21))THEN
-         CALL ctl_stop('lim_adv_x_2 : failed to release workspace arrays.')
+      IF( .NOT. wrk_release(2, 11,12,13,14,15,16,17,18,19,20,21) ) THEN
+         CALL ctl_stop( 'lim_adv_x_2 : failed to release workspace arrays.' )
       END IF
       !
@@ -247,9 +245,8 @@
       !! Reference:  Prather, 1986, JGR, 91, D6. 6671-6681.
       !!---------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
-      USE wrk_nemo, ONLY: zf0 => wrk_2d_11, zfx => wrk_2d_12, zfy => wrk_2d_13
-      USE wrk_nemo, ONLY: zbet => wrk_2d_14, zfm => wrk_2d_15, zfxx => wrk_2d_16
-      USE wrk_nemo, ONLY: zfyy => wrk_2d_17, zfxy => wrk_2d_18, zalg => wrk_2d_19
-      USE wrk_nemo, ONLY: zalg1 => wrk_2d_20, zalg1q => wrk_2d_21
+      USE wrk_nemo, ONLY:   wrk_use, wrk_release
+      USE wrk_nemo, ONLY:   zf0  => wrk_2d_11 , zfx   => wrk_2d_12 , zfy    => wrk_2d_13 , zbet => wrk_2d_14   ! 2D workspace
+      USE wrk_nemo, ONLY:   zfm  => wrk_2d_15 , zfxx  => wrk_2d_16 , zfyy   => wrk_2d_17 , zfxy => wrk_2d_18   !  -      -
+      USE wrk_nemo, ONLY:   zalg => wrk_2d_19 , zalg1 => wrk_2d_20 , zalg1q => wrk_2d_21                       !  -      -
       !!
       REAL(wp)                    , INTENT(in   ) ::   pdf                ! reduction factor for the time step
@@ -267,7 +264,6 @@
       !---------------------------------------------------------------------
 
-      IF(.NOT. wrk_use(2, 11,12,13,14,15,16,17,18,19,20,21))THEN
-         CALL ctl_stop('lim_adv_y_2 : requested workspace arrays unavailable.')
-         RETURN
+      IF(.NOT. wrk_use(2, 11,12,13,14,15,16,17,18,19,20,21) ) THEN
+         CALL ctl_stop( 'lim_adv_y_2 : requested workspace arrays unavailable.' )   ;   RETURN
       END IF
 
@@ -418,6 +414,6 @@
       ENDIF
       !
-      IF(.NOT. wrk_release(2, 11,12,13,14,15,16,17,18,19,20,21))THEN
-        CALL ctl_stop('lim_adv_y_2 : failed to release workspace arrays.')
+      IF( .NOT. wrk_release(2, 11,12,13,14,15,16,17,18,19,20,21) ) THEN
+        CALL ctl_stop( 'lim_adv_y_2 : failed to release workspace arrays.' )
       END IF
       !
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limdia_2.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limdia_2.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limdia_2.F90	(revision 2613)
@@ -29,5 +29,4 @@
 
    PUBLIC               lim_dia_2          ! called by sbc_ice_lim_2
-   PUBLIC               lim_dia_alloc_2    ! called by nemogcm
 
    INTEGER, PUBLIC ::   ntmoy   = 1 ,   &  !: instantaneous values of ice evolution or averaging ntmoy
@@ -63,23 +62,5 @@
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
-
-   FUNCTION lim_dia_alloc_2()
-      !!--------------------------------------------------------------------
-      !!                  ***  ROUTINE lim_dia_2  ***
-      !!--------------------------------------------------------------------
-      IMPLICIT none
-      INTEGER :: lim_dia_alloc_2
-      !!--------------------------------------------------------------------
-
-      ALLOCATE(aire(jpi,jpj), Stat=lim_dia_alloc_2)
-
-      IF(lim_dia_alloc_2 /= 0)THEN
-         CALL ctl_warn('lim_dia_alloc_2: failed to allocate array aire.')
-      END IF
-
-   END FUNCTION lim_dia_alloc_2
-
 
    SUBROUTINE lim_dia_2( kt )
@@ -192,17 +173,15 @@
        !!-------------------------------------------------------------------
        CHARACTER(len=jpchinf) ::   titinf
-       INTEGER  ::   jv            ! dummy loop indice
-       INTEGER  ::   ntot , ndeb 
-       INTEGER  ::   nv            ! indice of variable 
-       REAL(wp) ::   zxx0, zxx1    ! temporary scalars
+       INTEGER  ::   jv   ! dummy loop indice
+       INTEGER  ::   ntot , ndeb, nv, ierr   ! local integer
+       REAL(wp) ::   zxx0, zxx1              ! local scalars
 
        NAMELIST/namicedia/fmtinf, nfrinf, ninfo, ntmoy
        !!-------------------------------------------------------------------
 
-       ! Read Namelist namicedia
-       REWIND ( numnam_ice )
-       READ   ( numnam_ice  , namicedia )
+       REWIND( numnam_ice )                     ! Read Namelist namicedia
+       READ  ( numnam_ice  , namicedia )
        
-       IF(lwp) THEN
+       IF(lwp) THEN                             ! control print
           WRITE(numout,*)
           WRITE(numout,*) 'lim_dia_init_2 : ice parameters for ice diagnostics '
@@ -214,15 +193,14 @@
        ENDIF
 
-       ! masked grid cell area
+       ALLOCATE( aire(jpi,jpj) , STAT=ierr )    ! masked grid cell area
+       IF( lk_mpp    )   CALL mpp_sum( ierr )
+       IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'lim_dia_init_2 : unable to allocate standard arrays' )
        aire(:,:) = area(:,:) * tms(:,:)
 
-       ! Titles of ice key variables :
-       nv = 1
+       nv = 1                                   ! Titles of ice key variables
        titvar(nv) = 'NoIt'  ! iteration number
        nv = nv + 1
        titvar(nv) = 'T yr'  ! time step in years
-       
        nbvt = nv - 1
-
        nv = nv + 1   ;   titvar(nv) = 'AEFN' ! sea ice area in the northern Hemisp.(10^12 km2)
        nv = nv + 1   ;   titvar(nv) = 'AEFS' ! sea ice area in the southern Hemisp.(10^12 km2)
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limdyn_2.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limdyn_2.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limdyn_2.F90	(revision 2613)
@@ -58,7 +58,8 @@
       !!              - treatment of the case if no ice dynamic
       !!---------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
-      USE wrk_nemo, ONLY: wrk_1d_1, wrk_1d_2
-      USE wrk_nemo, ONLY: zu_io => wrk_2d_1, zv_io => wrk_2d_2  ! ice-ocean velocity
+      USE wrk_nemo, ONLY:   wrk_use, wrk_release
+      USE wrk_nemo, ONLY:   wrk_1d_1, wrk_1d_2
+      USE wrk_nemo, ONLY:   zu_io => wrk_2d_1, zv_io => wrk_2d_2  ! ice-ocean velocity
+      !
       INTEGER, INTENT(in) ::   kt     ! number of iteration
       !!
@@ -66,14 +67,12 @@
       INTEGER  ::   i_j1, i_jpj        ! Starting/ending j-indices for rheology
       REAL(wp) ::   zcoef              ! temporary scalar
-      REAL(wp), POINTER, DIMENSION(:)     ::   zind     ! i-averaged indicator of sea-ice
-      REAL(wp), POINTER, DIMENSION(:)     ::   zmsk     ! i-averaged of tmask
+      REAL(wp), POINTER, DIMENSION(:) ::   zind     ! i-averaged indicator of sea-ice
+      REAL(wp), POINTER, DIMENSION(:) ::   zmsk     ! i-averaged of tmask
       !!---------------------------------------------------------------------
 
-      IF( (.NOT. wrk_use(1, 1,2)) .OR. (.NOT. wrk_use(2, 1,2)) )THEN
-         CALL ctl_stop('lim_dyn_2 : requested workspace arrays unavailable.')
-         RETURN
+      IF(  .NOT. wrk_use(1, 1,2)  .OR.  .NOT. wrk_use(2, 1,2)  ) THEN
+         CALL ctl_stop( 'lim_dyn_2 : requested workspace arrays unavailable.' )   ;   RETURN
       END IF
-      ! Set-up pointers to sub-arrays of workspaces
-      zind => wrk_1d_1(1:jpj)
+      zind => wrk_1d_1(1:jpj)      ! Set-up pointers to sub-arrays of workspaces
       zmsk => wrk_1d_2(1:jpj)
 
@@ -103,6 +102,6 @@
             !
             DO jj = 1, jpj
-               zind(jj) = SUM( frld (:,jj  ) )   ! = FLOAT(jpj) if ocean everywhere on a j-line
-               zmsk(jj) = SUM( tmask(:,jj,1) )   ! = 0          if land  everywhere on a j-line
+               zind(jj) = SUM( frld (:,jj  ) )   ! = REAL(jpj) if ocean everywhere on a j-line
+               zmsk(jj) = SUM( tmask(:,jj,1) )   ! = 0         if land  everywhere on a j-line
             END DO
             !
Index: branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limhdf_2.F90
===================================================================
--- branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limhdf_2.F90	(revision 2612)
+++ branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/LIM_SRC_2/limhdf_2.F90	(revision 2613)
@@ -25,10 +25,9 @@
 
    PUBLIC   lim_hdf_2         ! called by limtrp_2.F90
-   PUBLIC   lim_hdf_alloc_2   ! called by nemogcm.F90
 
    LOGICAL  ::   linit = .TRUE.   ! ! initialization flag (set to flase after the 1st call)
    REAL(wp) ::   epsi04 = 1e-04   ! constant
    
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   efact   ! ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   efact   ! metric coefficient
 
    !! * Substitution 
@@ -40,20 +39,4 @@
    !!----------------------------------------------------------------------
 CONTAINS
-
-   FUNCTION lim_hdf_alloc_2()
-      !!-------------------------------------------------------------------
-      !!                  ***  ROUTINE lim_hdf_alloc_2  ***
-      !!-------------------------------------------------------------------
-      INTEGER :: lim_hdf_alloc_2
-      !!-------------------------------------------------------------------
-      !
-      ALLOCATE( efact(jpi,jpj) , STAT=lim_hdf_alloc_2 )
-      !
-      IF( lim_hdf_alloc_2 /= 0 ) THEN
-         CALL ctl_warn( 'lim_hdf_alloc_2: failed to allocate efact array.' )
-      ENDIF
-      !
-   END FUNCTION lim_hdf_alloc_2
-
 
    SUBROUTINE lim_hdf_2( ptab )
@@ -74,6 +57,6 @@
       REAL(wp), DIMENSION(jpi,jpj), INTENT( inout ) ::   ptab   ! Field on which the diffusion is applied  
       !
-      INTEGER  ::  ji, jj      ! dummy loop indices
-      INTEGER  ::  its, iter   ! local integers
+      INTEGER  ::   ji, jj            ! dummy loop indices
+      INTEGER  ::   its, iter, ierr   ! local integers
       REAL(wp) ::   zalfa, zrlxint, zconv, zeps   ! local scalars
       CHARACTER (len=55) :: charout
@@ -87,8 +70,10 @@
       !
       IF( linit ) THEN              ! Metric coefficient (compute at the first call and saved in efact)
+         ALLOCATE( efact(jpi,jpj) , STAT=ierr )
+         IF( lk_mpp    )   CALL mpp_sum( ierr )
+         IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'lim_hdf_2 : unable to allocate standard arrays' )
          DO jj = 2, jpjm1  
             DO ji = fs_2 , fs_jpim1   ! vector opt.
-               efact(ji,jj) = ( e2u(ji,jj) + e2u(ji-1,jj  ) + e1v(ji,jj) + e1v(ji,jj-1) ) &
-                  &          / ( e1t(ji,jj) * e2t(ji,jj) )
+               efact(ji,jj) = ( e2u(ji,jj) + e2u(ji-1,jj) + e1v(ji,jj) + e1v(ji,jj-1) ) / ( e1t(ji,jj) * e2t(ji,jj) )
             END DO
          END DO
